require 'active_support/inflector'

module Jigsaw

  class Company
    
    attr_accessor :companyId, :name, :phone, :website, :stockSymbol, :stockExchange, :ownership, :employeeCount, :employeeRange, :revenue, :revenueRange, :industry1, :industry2, :industry3, :subIndustry1, :subIndustry2, :subIndustry3, :sicCode, :address, :city, :state, :zip, :country, :activeContact, :createdOn, :linkInJigsaw, :graveyarded, :updatedDate, :currentWiki, :currentLogo

    def initialize(json_object)
      @companyId        = json_object['companyId']  
      @name             = json_object['name']         
      @phone            = json_object['phone']        
      @website          = json_object['website']      
      @stockSymbol      = json_object['stockSymbol']  
      @stockExchange    = json_object['stockExchange']
      @ownership        = json_object['ownership']    
      @employeeCount    = json_object['employeeCount']
      @employeeRange    = json_object['employeeRange']
      @revenue          = json_object['revenue']      
      @revenueRange     = json_object['revenueRange'] 
      @industry1        = json_object['industry1']    
      @industry2        = json_object['industry2']    
      @industry3        = json_object['industry3']    
      @subIndustry1     = json_object['subIndustry1'] 
      @subIndustry2     = json_object['subIndustry2'] 
      @subIndustry3     = json_object['subIndustry3'] 
      @sicCode          = json_object['sicCode']      
      @address          = json_object['address']      
      @city             = json_object['city']         
      @state            = json_object['state']        
      @zip              = json_object['zip']          
      @country          = json_object['country']      
      @activeContact    = json_object['activeContact']
      @createdOn        = json_object['createdOn']    
      @linkInJigsaw     = json_object['linkInJigsaw'] 
      @graveyarded      = json_object['graveyarded']  
      @updatedDate      = json_object['updatedDate']  
      @currentWiki      = json_object['currentWiki']
      @currentLogo      = json_object['currentLogo']
    end    
    
    def self.find(api_key, id, options)
      
      options[:token] = api_key

      response = Request.company(id, options)

      company = self.new(response['companies'].first)
      
      # Return the hits info and the list of the company
      company
      
    end
    
  end
  
end