require "httparty"

module Jigsaw

  class Request

    attr_accessor :response

    include ::HTTParty
    format :json

    SEARCH_COMPANY_URL = 'https://www.jigsaw.com/rest/searchCompany.json'
    SEARCH_CONTACT_URL = 'https://www.jigsaw.com/rest/searchContact.json'
    COMPANY_URL        = 'https://www.jigsaw.com/rest/companies/'

    def self.search_company(options = {})
      request = new(SEARCH_COMPANY_URL, options)
      request.parsed_response
    end
    
    def self.search_contact(options = {})
      request = new(SEARCH_CONTACT_URL, options)
      request.parsed_response
    end
    
    def self.company(id, options = {})
      request = new(COMPANY_URL + id + ".json", options)
      request.parsed_response
    end

    def initialize(url, options)
      @response = self.class.get(url, :query => options)
    end

    def parsed_response
      @response.parsed_response
    end

  end

end